package ksnet.kspay;

import java.io.*;
import java.net.*;
import java.util.*;

import java.sql.*;

public class RealTimeBankingJDBC extends Thread
{
	public static boolean USE_DEBUG = false;

	public static void main(String[] args) throws Exception
	{
		CUtil.setConfig(args[0]);

		String Listen_Port = CUtil.get("Listen_Port");
		int port = Integer.parseInt(Listen_Port);

		if (port == 0) throw new IllegalArgumentException("ksnet-mrcv.ini Listen_Port ");

		ServerSocket	ss = new ServerSocket(port);

		while(true)
		{
			Socket	cs = ss.accept();

			String DEBUG_MODE = CUtil.get("DEBUG");
			if (DEBUG_MODE != null && DEBUG_MODE.equalsIgnoreCase("true")) RealTimeBankingJDBC.USE_DEBUG = true;
			else  RealTimeBankingJDBC.USE_DEBUG = false;

			new RealTimeBankingJDBC(cs).start();
		}
	}

	final static int FIRM_MSG_LEN = 300; //

	Socket cs;
	public RealTimeBankingJDBC(Socket cs)
	{
		this.cs = cs;
	}

	public void run()
	{
		DataOutputStream	out			= null;
		DataInputStream		in			= null;
		String			read_msg	= null;
		try {
			in = new DataInputStream(cs.getInputStream());

			byte[]	sbuf = new byte[512];
			int		read_len = 0, rest_len = 0, rtn_len = 0;


			if (300 != (rtn_len = in.read(sbuf, read_len, 300)))
			{
				throw new IOException("Read(recv) error -  б (" + read_len + ")!!");
			}
			read_len = read_len + rtn_len;

			read_msg = SUtil.toHanX(sbuf, 0, read_len);
			LUtil.println("RCV_MSG=[" + read_msg + "]");

			byte[] rbuf = parseMsg(sbuf);

			out = new DataOutputStream(cs.getOutputStream());
			out.write(rbuf);
			out.flush();

		}catch (Exception e) {
			LUtil.println(e.getMessage());
		}finally {
			try{if (in != null) in.close();}catch(Exception e){};
			try{if (out != null) out.close();}catch(Exception e){};
			try{if (cs != null) cs.close();}catch(Exception e){};
		}
	}

	public byte[] parseMsg(byte[] byte_data) throws Exception
	{
		boolean		ret = false;
		int			ipos = 0;

		if (byte_data[19] == '0' && byte_data[20] == '2' && byte_data[21] == '0' && byte_data[22] == '0')
		{
			//deal_sele = 20 : Ա, 51 : Ա
			//ߺüũ : deal_sele, cms_no, seq_no, deal_star_date, deal_star_time
			String	deal_code       = SUtil.toHanX(byte_data, ipos, 9   ); ipos +=  9 ;// ĺڵ
			String	comp_code       = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// üڵ
			String	bank_cd         = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// ڵ(R)
			String	mess_code       = SUtil.toHanX(byte_data, ipos, 4   ); ipos +=  4 ;// ޼ڵ
			String	job_diff        = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// 
			String	tran_numb       = SUtil.toHanX(byte_data, ipos, 1   ); ipos +=  1 ;// ۽Ƚ(Y2K  : )
			String	seq_no          = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ȣ
			String	tran_date       = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// 
			String	tran_time       = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ۽ð
			String	stan_resp_code  = SUtil.toHanX(byte_data, ipos, 4   ); ipos +=  4 ;// ڵ
			String	bank_resp_code  = SUtil.toHanX(byte_data, ipos, 4   ); ipos +=  4 ;// ڵ
			String	inqu_date       = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// ȸ
			String	inqu_no         = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ȸȣ
			String	bank_seq_no     = SUtil.toHanX(byte_data, ipos, 15  ); ipos +=  15;// ȣ
			String	bank_cd_3       = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// ڵ3ڸ
			String	filler_1        = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// 
			String	acco_numb       = SUtil.toHanX(byte_data, ipos, 15  ); ipos +=  15;// ¹ȣ
			String	comp_cnt        = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// Ǽ
			String	deal_sele       = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// ŷ
			String	in_bank_cd      = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// ڵ(S)
			String	total_amt       = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// ݾ
			String	bala_mone       = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// ܾ
			String	giro            = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// Աڵ
			String	rece_nm         = SUtil.toHanX(byte_data, ipos, 14  ); ipos +=  14;// 
			String	chec_no         = SUtil.toHanX(byte_data, ipos, 10  ); ipos +=  10;// ǥȣ
			String	cash            = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// (+¼ǥ)
			String	out_bank_chec   = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// Ÿǥݾ
			String	etc_chec        = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// ǥ, Ÿ
			String	cms_no          = SUtil.toHanX(byte_data, ipos, 16  ); ipos +=  16;// CMS_NO()
			String	deal_star_date  = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// ŷ
			String	deal_star_time  = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ŷð
			String	acco_seri_no    = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ŷ Ϸùȣ
			String	in_bank_cd_3    = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// ڵ3ڸ
			String	giro_3          = SUtil.toHanX(byte_data, ipos, 7   ); ipos +=  7 ;// Աڵ
			String	filler_2        = SUtil.toHanX(byte_data, ipos, 38  ); ipos +=  38;// 

			ret = DUtil.insert0200_300(deal_code,comp_code,bank_cd,mess_code,job_diff, tran_numb,seq_no,tran_date,tran_time,stan_resp_code,bank_resp_code,inqu_date,inqu_no,bank_seq_no,   bank_cd_3,filler_1,acco_numb,comp_cnt,deal_sele,in_bank_cd,total_amt,bala_mone,giro,rece_nm,chec_no,cash,out_bank_chec, etc_chec,cms_no,deal_star_date,deal_star_time,acco_seri_no,in_bank_cd_3,giro_3,filler_2);

			byte[] rbuf = (byte[])byte_data.clone();
			byte[] O_resp_code = {'0','0','0','0'};
			byte[] X_resp_code = {'9','9','9','9'};
			rbuf[19+2] = '1';// ޼ڵ
			if(ret)
			{
				System.arraycopy(O_resp_code,0,rbuf,47,4);// ڵ
				System.arraycopy(O_resp_code,0,rbuf,51,4);// ڵ
			}
			else
			{
				System.arraycopy(X_resp_code,0,rbuf,47,4);// ڵ
				System.arraycopy(X_resp_code,0,rbuf,51,4);// ڵ
			}

			return rbuf;
		}
		/* Ÿ Ҵ  */
		else if (byte_data[19] == '0' && byte_data[20] == '4' && byte_data[21] == '0' && byte_data[22] == '0')
		{
			String	deal_code       = SUtil.toHanX(byte_data, ipos, 9   ); ipos +=  9 ;// ĺڵ
			String	comp_code       = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// üڵ
			String	bank_cd         = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// ڵ
			String	mess_code       = SUtil.toHanX(byte_data, ipos, 4   ); ipos +=  4 ;// ޼ڵ
			String	job_diff        = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// 
			String	tran_numb       = SUtil.toHanX(byte_data, ipos, 1   ); ipos +=  1 ;// ۽Ƚ
			String	seq_no          = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ȣ
			String	tran_date       = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// 
			String	tran_time       = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ۽ð
			String	stan_resp_code  = SUtil.toHanX(byte_data, ipos, 4   ); ipos +=  4 ;// ڵ
			String	bank_resp_code  = SUtil.toHanX(byte_data, ipos, 4   ); ipos +=  4 ;// ڵ
			String	inqu_date       = SUtil.toHanX(byte_data, ipos, 8   ); ipos +=  8 ;// ȸ
			String	inqu_no         = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ȸȣ
			String	bank_seq_no     = SUtil.toHanX(byte_data, ipos, 15  ); ipos +=  15;// ȣ
			String	bank_cd_3       = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// ڵ3ڸ
			String	filler_1        = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// 
			String	org_seq_no      = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// ŷ ȣ
			String	out_account_no  = SUtil.toHanX(byte_data, ipos, 15  ); ipos +=  15;// ݰ¹ȣ
			String	in_account_no   = SUtil.toHanX(byte_data, ipos, 15  ); ipos +=  15;// Աݰ¹ȣ
			String	in_money        = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// Ƿڱݾ
			String	in_bank_cd      = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// Աڵ
			String	nor_money       = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// óݾ
			String	abnor_money     = SUtil.toHanX(byte_data, ipos, 13  ); ipos +=  13;// óҴɱݾ
			String	div_proc_cnt    = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// óǼ
			String	div_proc_no     = SUtil.toHanX(byte_data, ipos, 2   ); ipos +=  2 ;// óȣ
			String	ta_no           = SUtil.toHanX(byte_data, ipos, 6   ); ipos +=  6 ;// Ÿȣ
			String	not_in_amt      = SUtil.toHanX(byte_data, ipos, 9   ); ipos +=  9 ;// ԱݺҴݾ
			String	err_code        = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// ڵ
			String	in_bank_cd_3    = SUtil.toHanX(byte_data, ipos, 3   ); ipos +=  3 ;// Աڵ3ڸ
			String	filler_2        = SUtil.toHanX(byte_data, ipos, 98  ); ipos +=  98;// 

			ret = DUtil.insert0400_100(deal_code, comp_code, bank_cd, mess_code, job_diff, tran_numb, seq_no, tran_date, tran_time, stan_resp_code, bank_resp_code, inqu_date, inqu_no, bank_seq_no, bank_cd_3, filler_1, org_seq_no, out_account_no, in_account_no, in_money, in_bank_cd, nor_money, abnor_money, div_proc_cnt, div_proc_no, ta_no, not_in_amt, err_code, in_bank_cd_3, filler_2);

			byte[] rbuf = (byte[])byte_data.clone();
			byte[] O_resp_code = {'0','0','0','0'};
			byte[] X_resp_code = {'9','9','9','9'};
			rbuf[19+2] = '1';// ޼ڵ
			if(ret)
			{
				System.arraycopy(O_resp_code,0,rbuf,47,4);// ڵ
				System.arraycopy(O_resp_code,0,rbuf,51,4);// ڵ
			}
			else
			{
				System.arraycopy(X_resp_code,0,rbuf,47,4);// ڵ
				System.arraycopy(X_resp_code,0,rbuf,51,4);// ڵ
			}

			return rbuf;
		}
		else
		{
			throw new RuntimeException("ǵ  Դϴ.!!");
		}
	}
}

class MsgSaf extends TimerTask
{
	public MsgSaf ()
	{
		;
	}

	public void run()
	{
		;
	}
}

class LUtil
{
	static String LOG_DIR = null;
	private static synchronized boolean init()
	{
		if (null == LOG_FILE || CUtil.isNew())
		{
			LOG_DIR		= CUtil.get("LogDirPath"	);

			if (null == LOG_DIR) return false;
		}
		return true;
	}

	static Calendar LOG_CAL		= Calendar.getInstance();
	static String  LOG_DT		= null;
	static String  LOG_FILE		= null;

	private static synchronized void day_check(String curr_dt8)
	{
		if (LOG_DT == null || !LOG_DT.equals(curr_dt8))
		{
			File log_dir_file = new File(LOG_DIR, "log");
			if (!log_dir_file.exists())log_dir_file. mkdir();

			StringBuffer sb = new StringBuffer();

			sb.append(LOG_DIR);
			if (!LOG_DIR.endsWith("/") && !LOG_DIR.endsWith("\\")) sb.append('/');
			sb.append("log/");
			sb.append(curr_dt8);
			sb.append(".log");

			LOG_FILE = sb.toString();

			LOG_DT = curr_dt8;
		}
	}

	public static void println(Object pstr)
	{
		if (!init())
		{
			System.out.println("LogDirPath !!");
			return;
		}

		String curr_date = SUtil.getCurrDate();

		day_check(curr_date.substring(0,8));

		File openFile = new File(LOG_FILE);
		PrintStream out = null;

		try{
			if(openFile.exists()){
				out = new PrintStream(new FileOutputStream(LOG_FILE, true), true);
			}else{
				out = new PrintStream(new FileOutputStream(LOG_FILE), true);
			}

		if (pstr instanceof Throwable)
		{
			Throwable tw = (Throwable)pstr;
			tw.printStackTrace(out);
			out.println();
		}else
		{
			StringBuffer sb = new StringBuffer();

			sb.append("[");
			sb.append(curr_date.substring(8,10)).append(":").append(curr_date.substring(10,12)).append(":").append(curr_date.substring(12,14));
			sb.append("]" );
			sb.append(pstr);

			out.println(sb.toString());
		}
		}catch(Exception e)
		{
			e.printStackTrace();
		}finally {
			try{if (out != null) out.close();}catch(Exception e){};

		}
	}
}

class CUtil
{
	static String config_file = null;
	static long lastModified  = 0;

	public static Properties props = new Properties();

	public static synchronized void setConfig(String fpath)
	{
		if (!new File(fpath).exists()) throw new IllegalArgumentException("ȯϰο=["+fpath+"]");
		config_file = fpath;
	}

	public static synchronized boolean isNew()
	{
		try
		{
			File f = new File(config_file);
			long m_lastModified = f.lastModified();

			if (m_lastModified > lastModified + 2000)
			{
				props.load(new FileInputStream(f));

				lastModified = m_lastModified;

				return true;
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		return false;
	}

	public static String get(String kStr)
	{
		isNew();
		return props.getProperty(kStr);
	}
}

class DUtil
{
	static String DRIVER_NAME	= null;
	static String DB_URL		= null;
	static String USER_NAME		= "";
	static String PASSWORD		= "";

	public static Connection getConnection()
	{
		if (null == DRIVER_NAME || CUtil.isNew())
		{
			DRIVER_NAME		= CUtil.get("JDBC_DRIVER"	);
			DB_URL			= CUtil.get("JDBC_URL"		);
			USER_NAME		= CUtil.get("JDBC_USER"		);
			PASSWORD		= CUtil.get("JDBC_PASSWORD"	);
/*
LUtil.println("DRIVER_NAME=["+DRIVER_NAME+"]")	;
LUtil.println("DB_URL=["+DB_URL+"]")			;
LUtil.println("USER_NAME=["+USER_NAME+"]")		;
LUtil.println("PASSWORD=["+PASSWORD+"]")		;
*/
			if (USER_NAME	== null) USER_NAME	= "";
			if (PASSWORD	== null) PASSWORD	= "";
		}

		try{
			Class.forName (DRIVER_NAME);
			if (USER_NAME == null || USER_NAME.length() == 0)
				return DriverManager.getConnection(DB_URL);
			else
				return DriverManager.getConnection(DB_URL, USER_NAME, PASSWORD);
		}catch(Exception e)
		{
			LUtil.println(e);
		}
		return null;
	}

	public static boolean insert0200_300(String deal_code,String comp_code,String bank_cd,String mess_code,String job_diff,String tran_numb,String seq_no,String tran_date,String tran_time,String stan_resp_code,String bank_resp_code,String inqu_date,String inqu_no,String bank_seq_no,String bank_cd_3,String filler_1,String acco_numb,String comp_cnt,String deal_sele,String in_bank_cd,String total_amt,String bala_mone,String giro,String rece_nm,String chec_no,String cash,String out_bank_chec,String etc_chec,String cms_no,String deal_star_date,String deal_star_time,String acco_seri_no,String in_bank_cd_3,String giro_3,String filler_2)
	{
		Connection          con     = null;
		PreparedStatement   pstmt   = null;

		String  INS_QRY = "INSERT INTO TRADEDATA_TBL (deal_code,comp_code,bank_cd,mess_code,job_diff, tran_numb,seq_no,tran_date,tran_time,stan_resp_code,bank_resp_code,inqu_date,inqu_no,bank_seq_no,   bank_cd_3,filler_1,acco_numb,comp_cnt,deal_sele,in_bank_cd,total_amt,bala_mone,giro,rece_nm,chec_no,cash,out_bank_chec, etc_chec,cms_no,deal_star_date,deal_star_time,acco_seri_no,in_bank_cd_3,giro_3,filler_2) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

		int cnt =0;
		try {
			con = getConnection();
			con.setAutoCommit(false);

			pstmt   = con.prepareStatement(INS_QRY);

			pstmt.setString	(1, deal_code     );
			pstmt.setString	(2, comp_code     );
			pstmt.setString	(3, bank_cd       );
			pstmt.setString	(4, mess_code     );
			pstmt.setString	(5, job_diff      );
			pstmt.setString (6, tran_numb     );
			pstmt.setString	(7, seq_no        );
			pstmt.setString	(8, tran_date     );
			pstmt.setString	(9, tran_time     );
			pstmt.setString	(10,stan_resp_code);
			pstmt.setString	(11,bank_resp_code);
			pstmt.setString	(12,inqu_date     );
			pstmt.setString	(13,inqu_no       );
			pstmt.setString	(14,bank_seq_no   );
			pstmt.setString	(15,bank_cd_3     );
			pstmt.setString	(16,filler_1      );
			pstmt.setString	(17,acco_numb     );
			pstmt.setString	(18,comp_cnt      );
			pstmt.setString (19,deal_sele     );
			pstmt.setString	(20,in_bank_cd    );
			pstmt.setString	(21,total_amt     );
			pstmt.setString	(22,bala_mone     );
			pstmt.setString	(23,giro          );
			pstmt.setString	(24,rece_nm       );
			pstmt.setString	(25,chec_no       );
			pstmt.setString	(26,cash          );
			pstmt.setString	(27,out_bank_chec );
			pstmt.setString	(28,etc_chec      );
			pstmt.setString	(29,cms_no        );
			pstmt.setString	(30,deal_star_date);
			pstmt.setString	(31,deal_star_time);
			pstmt.setString	(32,acco_seri_no  );
			pstmt.setString	(33,in_bank_cd_3  );
			pstmt.setString	(34,giro_3        );
			pstmt.setString	(35,filler_2      );

			cnt     = pstmt.executeUpdate();

			con.commit();
			return true;
/*
		} catch(Throwable t) {
			t.printStackTrace();
*/
		}catch(Throwable e) {
			int sql_code = 0;
			if (e instanceof SQLException)//case 1:  // ORA-00001 (Ἲ  (ENT.EUA050PK) ˴ϴ)
			{
				sql_code = ((SQLException)e).getErrorCode();
			}
			try{con.rollback();}catch(SQLException se){}
			if(sql_code == 1){
				LUtil.println("ORA-00001 OK");
				return true;
			}
			LUtil.println(e);

		} finally {
			try {if(pstmt!=null){pstmt.close();pstmt= null;}}catch(Exception e){}
			try {if(con !=null) {con.close( );/*con = null;*/}}catch(Exception e){}
		}
		return false;
	} // end of insertVR method


	public static boolean insert0400_100(String deal_code, String comp_code, String bank_cd, String mess_code, String job_diff, String tran_numb, String seq_no, String tran_date, String tran_time, String stan_resp_code, String bank_resp_code, String inqu_date, String inqu_no, String bank_seq_no, String bank_cd_3, String filler_1, String org_seq_no, String out_account_no, String in_account_no, String in_money, String in_bank_cd, String nor_money, String abnor_money, String div_proc_cnt, String div_proc_no, String ta_no, String not_in_amt, String err_code, String in_bank_cd_3, String filler_2)
	{
		Connection          con     = null;
		PreparedStatement   pstmt   = null;

		String  INS_QRY = "INSERT INTO TA_ERR_TBL (deal_code, comp_code, bank_cd, mess_code, job_diff, tran_numb, seq_no, tran_date, tran_time, stan_resp_code, bank_resp_code, inqu_date, inqu_no, bank_seq_no, bank_cd_3, filler_1, org_seq_no, out_account_no, in_account_no, in_money, in_bank_cd, nor_money, abnor_money, div_proc_cnt, div_proc_no, ta_no, not_in_amt, err_code, in_bank_cd_3, filler_2) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

		int		amount		= 0;
		int cnt =0;
		try {
			con = getConnection();
			con.setAutoCommit(false);

			pstmt   = con.prepareStatement(INS_QRY);

			pstmt.setString	(1, deal_code     );
			pstmt.setString	(2, comp_code     );
			pstmt.setString	(3, bank_cd       );
			pstmt.setString	(4, mess_code     );
			pstmt.setString	(5, job_diff      );
			pstmt.setString (6, tran_numb     );
			pstmt.setString	(7, seq_no        );
			pstmt.setString	(8, tran_date     );
			pstmt.setString	(9, tran_time     );
			pstmt.setString	(10,stan_resp_code);
			pstmt.setString	(11,bank_resp_code);
			pstmt.setString	(12,inqu_date     );
			pstmt.setString	(13,inqu_no       );
			pstmt.setString	(14,bank_seq_no   );
			pstmt.setString	(15,bank_cd_3     );
			pstmt.setString	(16,filler_1      );
			pstmt.setString	(17,org_seq_no    );
			pstmt.setString	(18,out_account_no);
			pstmt.setString (19,in_account_no );
			pstmt.setString	(20,in_money      );
			pstmt.setString	(21,in_bank_cd    );
			pstmt.setString	(22,nor_money     );
			pstmt.setString	(23,abnor_money   );
			pstmt.setString	(24,div_proc_cnt  );
			pstmt.setString	(25,div_proc_no   );
			pstmt.setString	(26,ta_no         );
			pstmt.setString	(27,not_in_amt    );
			pstmt.setString	(28,err_code      );
			pstmt.setString	(29,in_bank_cd_3  );
			pstmt.setString	(30,filler_2      );

			cnt     = pstmt.executeUpdate();

			con.commit();
			return true;
/*
		} catch(Throwable t) {
			t.printStackTrace();
*/
		}catch(Throwable e) {
			int sql_code = 0;
			if (e instanceof SQLException)//case 1:  // ORA-00001 (Ἲ  (ENT.EUA050PK) ˴ϴ)
			{
				sql_code = ((SQLException)e).getErrorCode();
			}
			try{con.rollback();}catch(SQLException se){}
			if(sql_code == 1){
				LUtil.println("ORA-00001 OK");
				return true;
			}
			LUtil.println(e);

		} finally {
			try {if(pstmt!=null){pstmt.close();pstmt= null;}}catch(Exception e){}
			try {if(con !=null) {con.close( );/*con = null;*/}}catch(Exception e){}
		}
		return false;
	}
}

class SUtil
{
	static String getCurrDate()
	{
		Calendar cal = Calendar.getInstance();
		StringBuffer sb = new StringBuffer();
		int li_yyyy,li_MM,li_dd,li_hour,li_min,li_sec;

		li_yyyy = cal.get(Calendar.YEAR); li_MM = cal.get(Calendar.MONTH); li_dd = cal.get(Calendar.DATE);
		li_hour = cal.get(Calendar.HOUR_OF_DAY); li_min = cal.get(Calendar.MINUTE); li_sec = cal.get(Calendar.SECOND);

		sb.append(li_yyyy).append(li_MM<9 ? "0" : "").append(li_MM + 1).append(li_dd<10 ? "0" : "").append(li_dd);
		sb.append(li_hour<10 ? "0" : "").append(li_hour).append(li_min<10 ? "0" : "").append(li_min).append(li_sec<10 ? "0" : "").append(li_sec);

		return sb.toString();
	}

	static String toHanX(byte[] bsrc, int idx, int len)
	{
		String str = toHan(bsrc, idx, len);
		if (str == null) return null;

		return str.trim();
	}

	static String toHan(byte[] bsrc, int idx, int len)
	{
		try
		{
			return new String(bsrc, idx, len ,"ksc5601");
		}catch(java.io.UnsupportedEncodingException ue){}

		return null;
	}
}
